<?php

// BEGIN CONFIG OPTIONS

$default_change_freq = 'monthly';
$url_prefix = 'http://downloads.cncfps.com/';
$blacklist = array( 'cgi-bin', '.htpasswds', 'sitemap.xml.gz', 'renttfs', 'kfmaps' );

// END CONFIG OPTIONS

require_once(realpath('../phpuri.php'));

$cwd = realpath(dirname(__FILE__));
$filter = function($info, $key, $iter)
{
	global $blacklist;
	if (preg_match('/^\..*/', $info->getFilename()))
	{
		return false;
	}
	
	if($iter->hasChildren() && !in_array($info->getFilename(), $blacklist))
	{
		return true;
	}
	
	return $info->isFile();
};

$dirall = new RecursiveDirectoryIterator('./', RecursiveDirectoryIterator::SKIP_DOTS | RecursiveDirectoryIterator::KEY_AS_PATHNAME);
$dir = new RecursiveCallbackFilterIterator($dirall, $filter);
$files = new RecursiveIteratorIterator($dir);

header('Content-Type: application/xml');

$writer = new XMLWriter();
$writer->openURI('php://output');
$writer->setIndent(true);
$writer->startDocument('1.0', 'UTF-8');
$writer->startElementNS(NULL, 'urlset', 'http://www.sitemaps.org/schemas/sitemap/0.9');

$writer->startElement('url');
$writer->writeElement('loc', phpURI::parse($url_prefix)->join('sitemap.xml'));
$writer->writeElement('lastmod', date(DateTime::W3C));
$writer->writeElement('changefreq', 'always');
$writer->endElement(); // <url></url>

foreach($files as $file => $object)
{	
	$writer->startElement('url');
	
	$furi = phpURI::parse($url_prefix)->join($file);
	$furi = htmlentities($furi, ENT_COMPAT | ENT_XML1); //$furi = rawurlencode($furi);
	
	$writer->writeElement('loc', $furi); // <loc></loc>
	$writer->writeElement('lastmod', date(DateTime::W3C, $object->getMTime())); // <lastmod></lastmod>
	
	// TODO: read filename.ext.txt for metadata
	$writer->writeElement('changefreq', $default_change_freq); // <changefreq></changefreq> 
	
	$writer->endElement(); // </url>
}

$writer->endElement(); // </urlset>
$writer->endDocument(); // EOF
$writer->flush();

exit;
